// Copyright (c) 2024 Celestino Amoroso (celestino.amoroso@gmail.com).
// All rights reserved.

// token_test.go
package expr

import (
	"testing"
)

func TestDevString(t *testing.T) {
	type inputType struct {
		source     string
		sym        Symbol
		value      any
		wantResult string
	}

	inputs := []inputType{
		/*   1 */ {"100", SymInteger, 100, `[55]"100"{100}`},
		/*   2 */ {"+", SymPlus, nil, `[6]"+"{}`},
	}

	for i, input := range inputs {
		var tk *Token
		if input.value == nil {
			tk = NewToken(0, 0, input.sym, input.source)
		} else {
			tk = NewValueToken(0, 0, input.sym, input.source, input.value)
		}

		t.Logf("Test nr %2d: %q --> %q", i+1, input.source, input.wantResult)

		if s := tk.DevString(); s != input.wantResult {
			t.Errorf("wrong token from symbol '+': expected %q, got %q", input.wantResult, s)
		}
	}
}
